%define major_ver 5.4.1

Summary: A collection of SNMP protocol tools and libraries
Name: net-snmp
Version: %{major_ver}
Release: 1

License: MIT
Group: System Environment/Daemons
URL: http://net-snmp.sourceforge.net/
Source0: http://dl.sourceforge.net/net-snmp/net-snmp-%{major_ver}.tar.gz
Source1: net-snmpd.init
Source2: net-snmptrapd.init
Source3: net-snmpd.logrotate
Source4: net-snmptrapd.example.conf

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: openssl-devel coreutils

Requires: openssl

%description
SNMP (Simple Network Management Protocol) is a protocol used for
network management. The NET-SNMP project includes various SNMP tools:
an extensible agent, an SNMP library, tools for requesting or setting
information from SNMP agents, tools for generating and handling SNMP
traps, a version of the netstat command which uses SNMP, and a Tk/Perl
mib browser. This package contains the snmpd and snmptrapd daemons,
documentation, etc.

You will probably also want to install the net-snmp-utils package,
which contains NET-SNMP utilities.

Building option:
	--without tcp_wrappers : disable tcp_wrappers support

%package utils
Group: Applications/System
Summary: Network management utilities using SNMP, from the NET-SNMP project
Requires: %{name} = %{version}

%description utils
The net-snmp-utils package contains various utilities for use with the
NET-SNMP network management project.

Install this package if you need utilities for managing your network
using the SNMP protocol. You will also need to install the net-snmp
package.

%package devel
Group: Development/Libraries
Summary: The development environment for the NET-SNMP project
Requires: %{name} = %{version}

%description devel
The net-snmp-devel package contains the development libraries and
header files for use with the NET-SNMP project's network management
tools.

Install the net-snmp-devel package if you would like to develop
applications for use with the NET-SNMP project's network management
tools. You'll also need to have the net-snmp and net-snmp-utils
packages installed.

%package perl
Group: Development/Libraries
Summary: The perl NET-SNMP module and the mib2c tool
Requires: %{name} = %{version}, perl >= 5
BuildRequires: perl >= 5

%description perl
The net-snmp-perl package contains the perl files to use SNMP from within
Perl.

Install the net-snmp-perl package, if you want to use mib2c or SNMP with perl.


%prep
%setup -q -n %{name}-%{major_ver}

%build
export CC=cc
export CFLAGS="-qmaxmem=16384 -DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_AIX52 -D_AIX53 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include -I/usr/local/include"
export CXX=xlC
export CXXFLAGS="-qmaxmem=16384 -DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_AIX52 -D_AIX53 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include -I/usr/local/include"
export F77=xlf
export FFLAGS="-qmaxmem=16384 -DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_AIX51 -D_AIX53 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include -I/usr/local/include"
export LD=ld
export LDFLAGS="-L/opt/freeware/lib -L/usr/local/lib"


# these are the default MIBS
MIBS="snmpv3mibs mibII ucd_snmp notification notification-log-mib target agent_mibs agentx disman/event disman/schedule utilities host"
# define some additional MIBS to include
MIBS="$MIBS smux ucd-snmp/diskio mibII/mta_sendmail"

./configure \
    --prefix=/opt/freeware                              \
    --enable-static					\
    --enable-shared					\
    --with-logfile="/var/log/snmpd.log"			\
    --with-persistent-directory="/var/net-snmp"		\
    --with-mib-modules="$MIBS"				\
    --enable-ucd-snmp-compatibility			\
    --with-openssl					\
    --disable-embedded-perl				\
    --disable-ipv6					\
    --enable-mfd-rewrites				\
    --enable-local-smux					\
    --with-default-snmp-version="3"			\
    --with-sys-location="Unknown"			\
    --with-sys-contact="root@localhost"

# this would be the options instead of '--disable-ipv6' for IPv6 support
#    --enable-ipv6--enable-ipv6				\
#    --with-out-mib-modules="mibII/ipv6"		\

make %{?smp_mflags} 

cd perl
# Use just built libs for perl module building, not the system libs.
export NETSNMP_DONT_CHECK_VERSION=1
perl Makefile.PL -NET-SNMP-IN-SOURCE=true PREFIX=${RPM_BUILD_ROOT}/%{_prefix} INSTALLDIRS=vendor -NET-SNMP-CONFIG="sh ../../net-snmp-config"
perl -pi -e 's/^LD_RUN_PATH.*//;s/LD_RUN_PATH=\".*\" //;' default_store/Makefile OID/Makefile agent/Makefile agent/default_store/Makefile ASN/Makefile SNMP/Makefile
make %{?smp_mflags} 
cd ..

%install
%__rm -rf ${RPM_BUILD_ROOT}
%makeinstall ucdincludedir=${RPM_BUILD_ROOT}/opt/freeware/include/ucd-snmp


%__mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/snmp
/opt/freeware/bin/install -m 644 EXAMPLE.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/snmp/snmpd.conf
/opt/freeware/bin/install -m 644 %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/snmp/snmptrapd.conf

%__mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
/opt/freeware/bin/install -m 755 %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/snmpd
/opt/freeware/bin/install -m 755 %{SOURCE2} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/snmptrapd

%__mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d/
%__mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d/
ln -sf '../init.d/snmpd' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Ssnmpd
ln -sf '../init.d/snmpd' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Ksnmpd
ln -sf '../init.d/snmpd' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Ssnmpd
ln -sf '../init.d/snmpd' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Ksnmpd
ln -sf '../init.d/snmptrapd' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Ssnmptrapd
ln -sf '../init.d/snmptrapd' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Ksnmptrapd
ln -sf '../init.d/snmptrapd' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Ssnmptrapd
ln -sf '../init.d/snmptrapd' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Ksnmptrapd


%__mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
/opt/freeware/bin/install -m 644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/snmpd

# copy missing mib2c.conf files
cp local/mib2c.*.conf ${RPM_BUILD_ROOT}%{_datadir}/snmp

cd perl
make install_vendor
eval $(perl '-V:installvendorarch')

# remove special files
find $RPM_BUILD_ROOT -name perllocal.pod \
	-o -name .packlist \
	-o -name "*.bs" \
	-o -name Makefile.subs.pl \
	| xargs -i rm -f {}
cd ..


%__mkdir -p $RPM_BUILD_ROOT/usr/opt/perl5/lib/site_perl/5.8.2/aix-thread-multi/
%__mv $RPM_BUILD_ROOT/opt/freeware/lib/5.8.2/aix-thread-multi/* $RPM_BUILD_ROOT//usr/opt/perl5/lib/site_perl/5.8.2/aix-thread-multi/

# trim down massive ChangeLog
dd bs=1024 count=250 if=ChangeLog of=ChangeLog.trimmed


%preun
if [ "$1" = 0 ]
then
    /etc/rc.d/init.d/snmpd stop
    /etc/rc.d/init.d/snmptrapd stop
    %__rm -f %{_datadir}/snmp/mibs/.index
fi


%clean
%__rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root,-)
%doc AGENT.txt COPYING ChangeLog.trimmed EXAMPLE.conf FAQ NEWS PORTING README* TODO
%doc local/passtest local/README.mib2c local/ipf-mod.pl
%dir %{_sysconfdir}/snmp
%dir %{_sysconfdir}/logrotate.d
/etc/rc.d/init.d/snmpd
/etc/rc.d/init.d/snmptrapd
/etc/rc.d/rc2.d/Ssnmpd
/etc/rc.d/rc2.d/Ksnmpd
/etc/rc.d/rc3.d/Ssnmpd
/etc/rc.d/rc3.d/Ksnmpd
/etc/rc.d/rc2.d/Ssnmptrapd
/etc/rc.d/rc2.d/Ksnmptrapd
/etc/rc.d/rc3.d/Ssnmptrapd
/etc/rc.d/rc3.d/Ksnmptrapd
%config(noreplace) %{_sysconfdir}/logrotate.d/snmpd
%config(noreplace,missingok) %{_sysconfdir}/snmp/snmpd.conf
%config(noreplace,missingok) %{_sysconfdir}/snmp/snmptrapd.conf
%{_datadir}/snmp
%{_sbindir}/*
%{_libdir}/lib*.so*
%attr(0644,root,root) %{_mandir}/man[58]/*

%files utils
%defattr(-,root,root,-)
%{_bindir}/encode_keychange
%{_bindir}/fixproc
%{_bindir}/ipf-mod.pl
%{_bindir}/mib2c-update
%{_bindir}/snmp*
%{_bindir}/traptoemail
%attr(0644,root,root) %{_mandir}/man1/encode_keychange*.1*
%attr(0644,root,root) %{_mandir}/man1/fixproc*.1*
%attr(0644,root,root) %{_mandir}/man1/mib2c-update*.1*
%attr(0644,root,root) %{_mandir}/man1/snmp*.1*
%attr(0644,root,root) %{_mandir}/man1/traptoemail*.1*

%files devel
%defattr(0644,root,root,0755)
%{_libdir}/*.a
%{_libdir}/*.la
%{_includedir}/*
%attr(0755,root,root) %{_bindir}/net-snmp-config
%attr(0644,root,root) %{_mandir}/man1/net-snmp-config.1
%attr(0644,root,root) %{_mandir}/man3/[a-z]*.3

%files perl
%defattr(-,root,root)
%{_bindir}/mib2c
%{_bindir}/tkmib
/usr/opt/perl5/lib/site_perl/5.8.2/aix-thread-multi/*
%attr(0644,root,root) %{_mandir}/man1/mib2c.1
%attr(0644,root,root) %{_mandir}/man1/tkmib.1
%attr(0644,root,root) %{_mandir}/man3/*SNMP*.3


%changelog
* Thu Aug  9 2007  Michael Perzl (michael@perzl.org) 5.4.1-1
- First version for AIX5L v5.3
